function LLR = LLR_calc1_16(y,M,Sgw,Sgh,NR)

if M==2
    
    LLR = pdf_calc(y,Sgh,Sgw,NR,1,-1);
    
elseif M==4
    
    yr=real(y);
    yq=imag(y);
    
    b0 = pdf_calc(yr,Sgh,Sgw,NR,1,-1);
    b1 = pdf_calc(yq,Sgh,Sgw,NR,1,-1);
    
    LLR=reshape([b0;b1],1,log2(M)*length(b0));
    
    
elseif M==16
    yr=real(y);
    yq=imag(y);
    
    b0 = pdf_calc(yr,Sgh,Sgw,NR,1,-1);
    b11 = pdf_calc(yr,Sgh,Sgw,NR,-1,-3);
    b12 = pdf_calc(yr,Sgh,Sgw,NR,1,3);
    b1=min(b11,b12);    
    
    b2 = pdf_calc(yq,Sgh,Sgw,NR,1,-1);

    b31 = pdf_calc(yq,Sgh,Sgw,NR,-1,-3);
    b32 = pdf_calc(yq,Sgh,Sgw,NR,1,3);
    b3=min(b31,b32);
    
    
    LLR=reshape([b0;b1;b2;b3],1,log2(M)*length(b0));
    
    
end


end




