function [pun_pattern, tail_pattern] = Pun_Pattern( framesize,rate )

% don't puncture the systematic part
pun_pattern(1,:) = ones(1,framesize);


if (rate==1/3)
pun_pattern(2,:) = ones(1,framesize);
pun_pattern(4,:) = ones(1,framesize);
elseif (rate==1/2)
% puncture first parity stream
for xx1=1:2:framesize
   pun_pattern(2,xx1)=1; 
end
% puncture second parity stream
for xx2=2:2:framesize
    pun_pattern(4,xx2)=1;
end
end
%Eleminate the interleved systimatic o/p
pun_pattern(3,:) = zeros(1,framesize);
% tail_pattern = [1 1 1;1 1 1; 1 1 1;1 1 1];

tail_pattern = [0 0 0;0 0 0;0 0 0;0 0 0];
end
