function[h,H]=chan1(NR,NT,fft_l)
% NR : Number of Receiver antennas
% NT : Number of Transmitted antennas
% fft_l : is the length of ofdm symbol
nochan=NR*NT; %             NR*NT
L1=85;  % No of taps
h1=zeros(nochan,L1);
n1=[ 1    6    19    28    53    85];
Nch = length(n1);
% hh=1/sqrt(2)*(randn(nochan,Nch) + 1i*randn(nochan,Nch));
hh=(randn(nochan,Nch) + 1i*randn(nochan,Nch));

%  -------------- Generating the channel attenuations------------%
for ii=1:nochan         %Ntx X Nrx
    hh(ii,:)=hh(ii,:)./norm(hh(ii,:));
end
% ----------------- taps distribuion -----------------%
for mm=1:nochan
    QQQ=hh(mm,:) ;
    GG(n1)=QQQ;
    h1(mm,:)=GG;
    
end

%------------------------------------channel formation ---------------------------

h=reshape(h1,NR,NT,L1);  % the channel dimenssions -------------%
for k1=1:NR
    for k2=1:NT
        H(k1,k2,:)=fft(h(k1,k2,:),fft_l);% -FFT for the channel
    end
end
end