clear, clc, close all
Nt=10;
Nr=200;
Eb=1;
SNRdB = -10;
sgmw = sqrt(Eb*0.5*Nt*10.^(-SNRdB/10));
sgmh=1/sqrt(2);
V=[];
HS=[];
ZF=[];
% QQw=[];
tic
for n=1:1000
    H=(randn(Nr,Nt)+1j*randn(Nr,Nt))/sqrt(2);
    w=sgmw*(randn(Nr,1)+1j*randn(Nr,1));
    v=H'*w;
    hs=diag(H'*H);
%     zf=pinv(H)*w;
    zf=v./hs;
%     hs1=hs(1,1);
    V=[V; v];
    HS=[HS;hs];
    ZF=[ZF;zf];
%     [Q,R]=MGS(H);
%     Qw=Q'*w;
%     QQw=[QQw;Qw(1,1)];
    
end
toc
% Qrw=real(QQw);
H1=real(HS);
zf1=real(ZF);
% Pdf
% Vr=abs(V);
Vr=real(V);
df=0.1/ceil(1/sgmw);
df1=1/ceil(1/sgmw);
df2=10/ceil(1/sgmw);
%%%%%   Q'w
% [h,f]=hist(Qrw,min(Qrw):df:max(Qrw));
% h=h/(length(Qrw)*df);
% %%%%%   H W
[h1,f1]=hist(Vr,min(Vr):df2:max(Vr));
h1=h1/(length(Vr)*df2);
%%%%%   H^2
[h2,f2]=hist(H1,min(H1):df1:max(H1));
h2=h2/(length(H1)*df1);
%%%%%   ZF
[h,f]=hist(zf1,min(zf1):df:max(zf1));
h=h/(length(zf1)*df);
%%%%%
plot(f2,h2,'rx')
hold on
x=min(f):df:max(f);
x1=min(f1):df2:max(f1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% H W

p1=pdf_prod_gauss(x1,sgmh,sgmw,Nr);
% plot(x1,p1,'b')
% grid on
%  xlabel('$\lambda^{\nu}_{l,k}$')
%  ylabel('$p~(\lambda^{\nu}_{l,k})$')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% H square
x2=min(f2):df1:max(f2);

% p=((abs(x)./(2*sgmh^2)).^(Nr-1).*exp(-abs(x)./(2*sgmh^2)))./(2*sgmh^2*gamma(Nr));
% 
p2=exp ( (Nr-1).*log(abs(x2)./(2*sgmh^2)) + (-abs(x2)./(2*sgmh^2)) -  log(2*sgmh^2)- ((Nr-1)*log(Nr-1) -(Nr-1)+1/2*log(2*pi*(Nr-1)) ) );
plot(x2,p2,'b')
grid on
% xlabel('$\zeta_{l,k}$')
% ylabel('$p~(\zeta_{l,k})$')



%   x=min(Qrw):df*3:max(Qrw);
%   x=min(f):df:max(f);
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ZF
% p = pdf_QW(f,Nr,sgmh,sgmw); % Q'W
p = pdf_ZF1(x,Nr,sgmh,sgmw);
% plot(x,p,'b')
% grid on
% xlabel('$\alpha^{\nu}_{l,k}$')
% ylabel('$p~(\alpha^{\nu}_{l,k})$')

% mse = sum((p-h).^2)/length(p)
%  set(legend,'Interpreter','Latex');

% dcor = distcorr(Vr(1:2500),H1(1:2500))
% ROH=corr(Vr,H1)
% ROH1=corrcoef(Vr,H1)
% [HHH1,ppp1]=kstest2(Vr,H1)
% [HHH2,ppp2]=kstest2(h1,h2)
% [HHH,ppp]=kstest2(h,p)
% [HHH1,ppp1]=kstest2(h1,p1)
% [HHH2,ppp2]=kstest2(h2,p2)

[~,~,p_chi]=crosstab(H1(1:1000),Vr(1:1000))

[H_test1,pValue1] = KStest_CDF(h,p)
[H_test2,pValue2] = KStest_CDF(h1,p1)
[H_test3,pValue3] = KStest_CDF(h2,p2)


n1     =  length(p);
n2     =  length(h);
sampleCDF1  =  cumsum(p)/n1;

sampleCDF2  =  cumsum(h)/n2;


figure
plot(f,sampleCDF2,x,sampleCDF1)
% [Ha,Pa]=kstest(Vr)
% [Hb,Pb]=kstest(H1)

% S1 = Joint_PDF(f1,f1,Nr,sgmh,sgmw);
% var(Vr)+var(H1)
% var(Vr+H1)
toc



